// This configuration file is used by C++CMS and trafficctrl. Most of the
// format is described on the C++CMS website at:
//    http://cppcms.com/wikipp/en/page/cppcms_1x_config
// Its syntax is JSON with the addition of C++ single line remarks, as seen
// here.

// NOTE: At this time no form of security is provided in this application. Its
//       expected it will be run through a proxy that will provide httpS & an
//       authentication mechanism.



{
// The database to use. See the C++DB connection string reference at:
//     http://cppcms.com/sql/cppdb/connstr.html
// This is a MySQL example replace the {...} parts with your site's settings.
	"trafficctrl": {
		"db": "mysql:user={username};password={password};database={db_name};@pool_size=10;@opt_reconnect=1"
// Root URI (path) within a site. If using the stand alone HTTP server this
// needs to match "http.script". But in that case leave both "".
		"root_uri": "", // root path on the hosting site. "" = "/"
	},



// These are C++CMS engine settings. See here for details:
//   http://cppcms.com/wikipp/en/page/cppcms_1x_config

// This is a stand alone HTTP server setup:
//	"service": {
//		"api" :   "http", // fastcgi
//		"ip": "0.0.0.0",
//		"port" :  8080
//		// or "socket": "path..."
//	},
//	"http" : { "script": "" },

// This is a FastCGI example, which could be used to provide HTTPS & passwords
// via the host service:
	"service": {
		"api" :   "fastcgi",
		// To serve on a TCP socket: "ip": "0.0.0.0", "port":  8080
		// or a socket. preferred if lesser privlieged users have access
		// to the server:
		"socket": "/run/poorman-ids/traffcctl.fcgi"
	},

	// In context of restricted access environment this is probably OK.
	"security" : {
		"display_error_message": true,
		// This requires JFP patches applied to C++CMS
		//"email_error_message": "SysOp@domain.net",
	},

// This tells us to run in background, as a daemon and to send errors to
// SysLog. You can run this at the console by remarking out everything below.
// Well.. other than the final '}'
	"daemon": {
		"enable": true,
		"lock":   "/run/poorman-ids/trafficctrl.pid",
	},
	"logging": {
		"syslog": {
			"enable": true,
			"id":     "trafficctrl"
		}
	}
}
